//Include file for 44100Hz to 32KHz.  Greatest Common Denominator (GCD) = 320/147.

#define HALFB 0						// Half band flag
#define NUPST 2						// Number of up stages
#define PVTFL 1						// Pivot flag
#define NDWNS 0						// Number of down stages
#define STAGE 3						// Number of total stages 
#define NINPS 441					// Number of imput samples (Should be a even multiple of the GCD 
#define NOUTS 320					// Number of output samples (Should be be the same multiple as above of the GCD

#define INTP1 2
#define DOWN1 1
#define LENG1 307					// LENG1 = length of stage filter
#define PLEN1 154					// PLEN1 = MLEN1/INTP1 (polyphase length)
#define MLEN1 308					// MLEN1 = LENG1 + enough to make even length for polyphase
#define SHFT1 0
#define NINP1 NINPS					// NINPS (...or NOUTS) 441
#define SZIN1 (NINP1 + ((LENG1-1)/INTP1) + 1) // 441 + (306/2) + 1 = 595


#define INTP2 5
#define DOWN2 1
#define LENG2 21					// LENG2 = length of stage filter
#define PLEN2 5						// PLEN2 = MLEN2/INTP2 (polyphase length)
#define MLEN2 25					// MLEN2 = LENG2 + enough to make even length for polyphase
#define SHFT2 0
#define NINP2 ((NINP1*INTP1)/DOWN1)	// (NINPx*INTPx)/DOWNx  441*2/1 = 882
#define SZIN2 (NINP2 + ((LENG2-1)/INTP2) + 1) // 882 + 20/5 + 1 = 887

#define INTP3 32
#define DOWN3 441
#define LENG3 97					// LENG3 = length of stage filter
#define PLEN3 4		  				// PLEN2 = MLEN2/INTP2 (polyphase length)
#define MLEN3 128					// MLEN2 = LENG2 + enough to make even length for polyphase
#define SHFT3 0
#define NINP3 ((NINP2*INTP2)/DOWN2)	// (NINPx*INTPx)/DOWNx =  882*5/1 = 4410
#define SZIN3 (NINP3 + ((LENG3-1)/INTP3) + 1) // 4410 + 96/32 + 1 =4414

#define NINP4 ((NINP3*INTP3)/DOWN3)	// (NINPx*INTPx)/DOWNx =  4410*32/441 = 320
#define SZIN4 NINP4 + 1  			// for last decimation stage only 148


#define OFFS1 (LENG1-1)/(2*DOWN1)	//
#define OFFS2 (LENG2-1)/(2*DOWN2)	// 
#define OFFS3 (LENG3-1)/(2*DOWN3)	//  

#if OFFS3 < 1
#define OF2S3 1
#else
#define OF2S3 OFFS3
#endif

#define TOFS1 OFFS1							// 
#define TOFS2 ((INTP2*TOFS1)/DOWN2 + OFFS2)	// 
#define TOFS3 ((INTP3*TOFS2)/DOWN3 + OF2S3)	// 
//#define T2FS3 57

//#define DOFS3 (NOUTS-TOFS3+1)		// Offset used to strip filter delays (zeros) off buffers

#define DOFS3 NOUTS